;##################################################################
; CPUSpeed.Asm
;##################################################################

/*
Many thanks to Jibz and MichaelW
Thanks also to Thomas Latuske for the article at Code Project
*/

#Define WM_INITDIALOG 110h
#Define WM_COMMAND 111h
#Define WM_CLOSE 10h
#Define LB_ADDSTRING 180h
#Define REALTIME_PRIORITY_CLASS 100h
#Define THREAD_PRIORITY_TIME_CRITICAL 15
#Define IDD_DLG1 1000

CODE SECTION

Start:
	invoke GetModuleHandleA, 0
	invoke DialogBoxParamA,eax,IDD_DLG1,0,ADDR DlgProc,0
	invoke ExitProcess,0

DlgProc FRAME hwnd,uMsg,wParam,lParam

	LOCAL Cnvrt[32]	:B
	LOCAL Speed		:D

	mov eax,[uMsg]
	cmp eax,WM_INITDIALOG
	jne >.WMCOMMAND
		jmp >>.EXIT

	.WMCOMMAND
	cmp eax,WM_COMMAND
	jne >>.WMCLOSE
		mov eax,[wParam]
		cmp ax,1002
		jne >>.SINGLE
			invoke CPUSpeed
			invoke wsprintfA,offset Cnvrt,"Clks/Sec = %u",eax
			add esp,12
			invoke SendDlgItemMessageA,[hwnd],1001,LB_ADDSTRING,0,offset Cnvrt
			invoke CPUSpeed
			invoke wsprintfA,offset Cnvrt,"Clks/Sec = %u",eax
			add esp,12
			invoke SendDlgItemMessageA,[hwnd],1001,LB_ADDSTRING,0,offset Cnvrt
			invoke CPUSpeed
			invoke wsprintfA,offset Cnvrt,"Clks/Sec = %u",eax
			add esp,12
			invoke SendDlgItemMessageA,[hwnd],1001,LB_ADDSTRING,0,offset Cnvrt
			invoke CPUSpeed
			invoke wsprintfA,offset Cnvrt,"Clks/Sec = %u",eax
			add esp,12
			invoke SendDlgItemMessageA,[hwnd],1001,LB_ADDSTRING,0,offset Cnvrt
			invoke CPUSpeed
			invoke wsprintfA,offset Cnvrt,"Clks/Sec = %u",eax
			add esp,12
			invoke SendDlgItemMessageA,[hwnd],1001,LB_ADDSTRING,0,offset Cnvrt
			invoke CPUSpeed
			invoke wsprintfA,offset Cnvrt,"Clks/Sec = %u",eax
			add esp,12
			invoke SendDlgItemMessageA,[hwnd],1001,LB_ADDSTRING,0,offset Cnvrt
			invoke CPUSpeed
			invoke wsprintfA,offset Cnvrt,"Clks/Sec = %u",eax
			add esp,12
			invoke SendDlgItemMessageA,[hwnd],1001,LB_ADDSTRING,0,offset Cnvrt
			invoke CPUSpeed
			invoke wsprintfA,offset Cnvrt,"Clks/Sec = %u",eax
			add esp,12
			invoke SendDlgItemMessageA,[hwnd],1001,LB_ADDSTRING,0,offset Cnvrt
		.SINGLE
		cmp ax,1003
		jne >>.EXIT
			invoke CPUSpeed
			invoke wsprintfA,offset Cnvrt,"Clks/Sec = %u",eax
			add esp,12
			invoke SendDlgItemMessageA,[hwnd],1001,LB_ADDSTRING,0,offset Cnvrt
		jmp >.EXIT

	.WMCLOSE
	cmp eax,WM_CLOSE
	jne >.DEFPROC
		INVOKE EndDialog,[hwnd],0

	.DEFPROC
		xor eax,eax
		ret

	.EXIT

	xor eax,eax
	inc eax
	ret
ENDF

CPUSpeed FRAME
	uses ebx,edi,esi
	LOCAL hProcess			:D
	LOCAL hThread			:D
	LOCAL PriorityClass		:D
	LOCAL Priority			:D
	LOCAL timer				:Q
	LOCAL PerformanceCount	:Q
	LOCAL Frequency			:Q

	/*
	Returns the number of clocks per second in EDX:EAX
	*/

	invoke GetCurrentProcess
	mov [hProcess],eax
	invoke GetCurrentThread
	mov [hThread],eax
	invoke GetPriorityClass,[hProcess]
	mov [PriorityClass],eax
	invoke GetThreadPriority,[hThread]
	mov [Priority],eax

	invoke QueryPerformanceFrequency,offset Frequency

	mov esi,[Frequency]
	mov edi,[Frequency+4]
	
	invoke SetPriorityClass,[hProcess], REALTIME_PRIORITY_CLASS
	invoke SetThreadPriority,[hThread], THREAD_PRIORITY_TIME_CRITICAL
	invoke Sleep,0

	invoke QueryPerformanceCounter,offset PerformanceCount
	mov ebx,[PerformanceCount]

	:
	invoke QueryPerformanceCounter,offset PerformanceCount
	mov eax,[PerformanceCount]
	cmp ebx,eax
	je <
	add esi,eax
	adc edi,[PerformanceCount+4]

	rdtsc
	mov [timer],eax
	mov [timer+4],edx

	:
	invoke QueryPerformanceCounter,offset PerformanceCount
	cmp edi,[PerformanceCount+4]
	ja <
	cmp esi,[PerformanceCount]
	ja <

	rdtsc
	sub eax,[timer]
	sbb edx,[timer+4]
	push eax,edx

	invoke SetThreadPriority, [hThread], [PriorityClass]
	invoke SetPriorityClass, [hProcess], [Priority]

	pop edx,eax

	RET
ENDF
